(*
   (c) Joachim Mohr
   Alle Rechte vorbehalten.
*)

{$OVERFLOWCHECKS ON} //damit keine zu groe Integerzahlen eingegeben werden
                     //vergert die Exe-Datei um ca 500 Bytes

unit Unitbrr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Ez1: TEdit;
    En1: TEdit;
    Ez2: TEdit;
    En2: TEdit;
    Ez: TEdit;
    En: TEdit;
    LGleich: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    BPlus: TButton;
    Bminus: TButton;
    Bmal: TButton;
    Bdiv: TButton;
    EOp: TEdit;
    Memo1: TMemo;
    Button1: TButton;
    Label4: TLabel;
    BAufgabe: TButton;
    BLevel: TButton;
    Eg1: TEdit;
    Eg2: TEdit;
    Eg: TEdit;
    L1: TLabel;
    L2: TLabel;
    LErg: TLabel;
    Button3: TButton;
    ENr: TEdit;
    BArt: TButton;
    procedure BGleichClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Ez1KeyPress(Sender: TObject; var Key: Char);
    procedure Ez1Change(Sender: TObject);
    procedure BAufgabeClick(Sender: TObject);
    procedure BLevelClick(Sender: TObject);
    procedure EgChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ENrKeyPress(Sender: TObject; var Key: Char);
    procedure ENrClick(Sender: TObject);
    procedure BArtClick(Sender: TObject);
    procedure ENrChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const leicht='leicht'; //kommt mehrmals vor
      mittel='mittel';
      schwer='schwer';
      sehrschwer='sehr schwer';
      echt='echte Brche';
      unecht='unechte Brche';
      gemischt='gemischte Zahlen';
Hilfe='Brche eintippen!'#13#10+
'Dann "+", "-", "*" oder ":" anklicken.'#13#10+
'----------------------------------------------'#13#10+
'           Zum ben'#13#10+
'Lege Papier und Fller bereit!'#13#10+
'Whle Schwierigkeitsgrad "leicht", "mittel" ,"schwer" '#13#10+
'      oder "sehr schwer"! (Ab "schwer" wird das groe'#13#10+
'      Einmaleins verlangt.)'#13#10+
'Whle Art der Brche "echte Brche", "unechte Brche"'#13#10+
'      oder "gemischte Zahlen"!'#13#10+
'(Entsprechende Knpfe mehrmals anklicken!)'#13#10+
'Whle "Aufgabe" und schreibe die Aufgabe mit Nr. ab!'#13#10+
'Wenn Du fertig gerechnet hast, "+", "-", "*" oder ":"'#13#10+
'anklicken, je nachdem, was Du gerade bst oder was'#13#10+
'der Computer (rot) vorschlgt.'#13#10+
'berprfe Dein Ergebnis und hake es ab bzw. suche'#13#10+
'Deinen Fehler an Hand der Computerrechnung.'#13#10+
'Hinweis: Nr. 3a (Addition/leicht/echte Brche) o..'#13#10+
'         ist auf jedem Computer dieselbe Aufgabe.'#13#10+
'----------------------------------------------'#13#10+
'     Viel Spa mit dem Programm!'#13#10+
'     (c) Joachim Mohr, 28.08.2001'#13#10+
'     Rottenburg am Neckar';

var
  Form1: TForm1;

implementation

{$R *.DFM}
function ggT(a,b:integer):integer;
   var c:integer;
begin
    repeat
      c:=a mod b;
      a:=b;
      b:=c;
    until c=0;
    result:=a
end;

function kgV(a,b:integer):integer;
begin
  result:=a*b div ggT(a,b);
end;

procedure kuerze(var z,n:integer);
  var t:integer;
begin
  t:=ggT(z,n);
  z:=z div t;
  n:=n div t;
  if n<0 then Begin
    n:=-n; //positiv
    z:=-z;
  End;
end;

function TextkgV(const n1,n2,n:integer):string;
begin
  result:='kgV('+intToStr(n1)+','+intToStr(n2)+')='+intToStr(n);
end;

procedure gemZahl(const z,n:integer; var q,r:integer); // z/n=q+r/n
begin //hier stets n>0. Mglicherweise z<0
  if abs(z)<n then Begin
    q:=0;
    r:=z;
  End else Begin
    q:=abs(z) div n;
    r:=abs(z)-n*q;
    if z<0 then BEgin
      q:=-q;
      r:=-r;
    ENd;
  End;
end;

procedure Dreizeiler(a,b,c:string);
   var aa,bb,cc:string;
       n,k:integer;
begin
  with Form1.memo1 do Begin
    while lines.count<3 do lines.Add('');
    n:=lines.count-1;
    aa:=trimright(lines[n-2]);
    bb:=lines[n-1]; //bestimmt Einrckung
    cc:=trimright(lines[n]);
    k:=length(aa);
    if length(bb)>k then k:=length(bb);
    if length(cc)>k then k:=length(cc);
    while length(aa)<k do aa:=aa+' ';
    while length(bb)<k do bb:=bb+' ';
    while length(cc)<k do cc:=cc+' ';
    k:=length(a);
    if length(c)>k then k:=length(c);
    if b='-' then Begin
      b:=''; //#151
      while length(b)<k do b:=b+''; //Bruchstrich #151 gengend lang
      while length(a)<length(c)-1 do a:=' '+a+' ';
      while length(c)<length(a)-1 do c:=' '+c+' ';
    End;
    lines[n-2]:=aa+a;
    lines[n-1]:=bb+b;
    lines[n]  :=cc+c;
  End;
end;

function nichtNull(const k:integer):string;
begin
  if k=0 then result:='' else result:=intToStr(k);
  if k<0 then result:=result+'+ ' //Subtraktion negativ
end;

procedure Textkuerze(g,a,b:integer);
  var c,d:integer;
begin
  //  a              c
  //  - = (gekrzt)= -
  //  b              d
  if a=0 then exit;
  c:=a;
  d:=b;
  kuerze(c,d);
  if abs(b)=abs(d) then exit;
  Dreizeiler('',NichtNull(g),'');
  Dreizeiler(intToStr(a),'-',intToStr(b));
  Dreizeiler('',' = '+NichtNull(g),'');
  Dreizeiler(intToStr(c),'-',intToStr(d));
  Dreizeiler('',' (... mit '+IntToStr(ggT(a,b))+') ','');
end;

function TextErweitereAuf(var g,a,b:integer; const c:integer):string;
begin
  //  a               d
  //  - =(erweitert)= -     (c Vielfaches von b
  //  b               c
  if abs(b)=abs(c) then exit;
  Dreizeiler('','   '+NichtNull(g),'');
  Dreizeiler(intToStr(a),'-',intToStr(b));
  Dreizeiler('',' = '+NichtNull(g),'');
  a:=a*c div b;
  Dreizeiler(intToStr(a),'-',intToStr(c));
  Dreizeiler('',' (... mit '+intToStr(c div b)+')','');
end;

Procedure NachHilfeAnfangstext(const ueberschr:string; var g1,z1,n1,g2,z2,n2:integer);
begin
  with Form1.Memo1 do Begin
    lines.Clear;
    lines.Add('      '+ueberschr+#13#10+
              '      Aufgabe '+form1.ENr.text+' ('+
              form1.blevel.caption+'/'+
              form1.bart.caption+')'#13#10+
               '*) Ausgangsbrche krzen mit ...'#13#10#13#10#13#10);
    Dreizeiler('','   ','');
    Textkuerze(g1,z1,n1);
    Dreizeiler('','  ','');
    Textkuerze(g2,z2,n2);
    kuerze(z1,n1);
    kuerze(z2,n2);
  End;
end;

procedure NachHilfePlusMinus(var g1,z1,n1,g2,z2,n2,n:integer);
begin
  n:=kgV(n1,n2);
  with Form1.memo1 do Begin
    lines.add('*) Brche erweitern auf '+TextKgV(n1,n2,n)+' mit ...'#13#10#13#10#13#10);
    TextErweitereAuf(g1,z1,n1,n);
    TextErweitereAuf(g2,z2,n2,n);
  End;
end;




procedure Nachhilfeaddiere(g1,g2,z1,n1,z2,n2:integer);
  var z,n,g:integer;
begin
  with Form1 do Begin
    l1.Caption:='1. Summand';
    l2.Caption:='2. Summand';
    lerg.Caption:='Summe';
  End;
  with Form1.memo1 do Begin
    NachHilfeAnfangstext('Addition',g1,z1,n1,g2,z2,n2);
    NachHilfePlusMinus(g1,z1,n1,g2,z2,n2,n);
    z:=z1+z2;
    text:=text+'*) Zhler addieren, Nenner beibehalten';
    if (g1>0) or (g2>0) then text:=Text+','#13#10+'   ganzzahlige Teile addieren';
    text:=text+#13#10#13#10#13#10#13#10;
    Dreizeiler('','   '+NichtNull(g1),'');
    Dreizeiler(intToStr(z1),'-',intToStr(n));
    Dreizeiler('',' + '+NichtNull(g2),'');
    Dreizeiler(intToStr(z2),'-',intToStr(n));
    Dreizeiler('',' = '+NichtNull(g1+g2),'');
    Dreizeiler(intToStr(z),'-',intToStr(n));
    g:=z div n; //ganzzahligerAnteil
    z:=z mod n; // Jetzt Bruch g'z/n
    if g>0 then Begin
      Dreizeiler('',' = '+intToStr(g+g1+g2),'');
      Dreizeiler(intToStr(z),'-',intToStr(n));
    End;
    text:=text+#13#10'*) Ergebnis krzen, falls mglich '#13#10#13#10#13#10#13#10;
    Dreizeiler('','   ','');
    TextKuerze(g+g1+g2,z,n);
  End;
end;

procedure  addiere(g1,g2,z1,n1,z2,n2:integer; var g,z,n:integer);
begin
  //   z1     z2    z1*n2+n1*z2+(g1+g2)*n1*n2
  // g1-- + g2- =  --------------------------
  //   n1     n2           n1*n2
  Nachhilfeaddiere(g1,g2,z1,n1,z2,n2);
  kuerze(z1,n1);
  kuerze(z2,n2);
  n:=n1*n2;
  z:=z1*n2+n1*z2+(g1+g2)*n;
  kuerze(z,n);
  gemZahl(z,n,g,z);

end;

procedure Nachhilfesubtrahiere(g1,g2,z1,n1,z2,n2:integer);
  var z,n,g,z10,g10,z0:integer;
begin
  with Form1 do Begin
    l1.Caption:='Minuend';
    l2.Caption:='Subtrahend';
    lerg.Caption:='Differenz';
  End;
  with Form1.memo1 do Begin
    NachHilfeAnfangstext('Subtraktion',g1,z1,n1,g2,z2,n2);
    NachHilfePlusMinus(g1,z1,n1,g2,z2,n2,n);
    z:=z1-z2;
    g10:=g1;
    z10:=z1;
    while (z<0) and (g1>0) do BEgin
      z :=z +n;
      z1:=z1+n;
      dec(g1);
    ENd;
    text:=text+'*) Zhler subtrahieren, Nenner beibehalten';
    if (g1<>0) or (g2<>0) then
      text:=text+','#13#10+'   ganzzahlige Teile subtrahieren';
    text:=text+#13#10#13#10#13#10#13#10;
    Dreizeiler('','   '+NichtNull(g1),'');
    Dreizeiler(intToStr(z1),'-',intToStr(n));
    Dreizeiler('',' - '+NichtNull(g2),'');
    Dreizeiler(intToStr(z2),'-',intToStr(n));
    Dreizeiler('',' = '+NichtNull(g1-g2),'');
    Dreizeiler(intToStr(z),'-',intToStr(n));
    // Jetzt ist Differenz = z/n
    g:=abs(z) div n;   //ganzzahligerAnteil. Zuerst ohne Vorzeichen gerechnet
    z0:=abs(z) mod n; 
    if z<0 then Begin
      z:=-z0;
      g:=-g;
    End;
    // Jetzt ist Differenz = g'z/n Falls Negativ g<0 und z<0
    if g<>0 then Begin
      Dreizeiler('',' = '+intToStr(g),'');
      Dreizeiler(inttostr(z0),'-',inttostr(n));
    End;
    if (g1<g10) and (z>0) then Begin
      text:=text+'   Vorher Minuenden umformen:'#13#10#13#10#13#10#13#10;
      Dreizeiler('','   ','');
      Dreizeiler('',intToStr(g10),'');
      Dreizeiler(IntToStr(z10),'-',inttostr(n));
      Dreizeiler('',' = '+intToStr(g1),'');
      Dreizeiler(inttoStr(z1),'-',inttostr(n));
    End;
    text:=text+#13#10'*) Ergebnis krzen, falls mglich '#13#10#13#10#13#10#13#10;
    dreizeiler('','   ','');
    TextKuerze(g+g1-g2,z,n);
    if (z<0) or (g+g1-g2<0) then
    text:=text+#13#10#13#10'Falls Du noch keine negativen Zahlen kennst,'#13#10+
               'heit Dein Ergebnis jetzt:Geht nicht!';
  End;
end;

procedure  subtrahiere(g1,g2,z1,n1,z2,n2:integer; var g,z,n:integer);
begin
  //   z1     z2    z1*n2-n1*z2+(g1-g2)*n1*n2
  // g1-- + g2- =  --------------------------
  //   n1     n2           n1*n2
  Nachhilfesubtrahiere(g1,g2,z1,n1,z2,n2);
  kuerze(z1,n1);
  kuerze(z2,n2);
  n:=n1*n2;
  z:=z1*n2-n1*z2+(g1-g2)*n;
  kuerze(z,n);
  gemZahl(z,n,g,z);
end;



procedure Nachhilfemultiplizieren(g1,g2,z1,n1,z2,n2:integer);
  var z10,z20,z,n,q,r:integer;
begin
  with Form1 do Begin
    l1.Caption:='1. Faktor';
    l2.Caption:='2. Faktor';
    lerg.Caption:='Produkt';
  End;
  with Form1.memo1 do Begin
    NachHilfeAnfangstext('Multiplikation',g1,z1,n1,g2,z2,n2);
    if (g1<>0) or (g2<>0) then
      text:=text+'*) Gemischte Zahl in unechten Bruch umwandeln:'#13#10#13#10#13#10#13#10;
    z10:=z1+g1*n1;
    z20:=z2+g2*n2;
    if g1<>0 then Begin
      Dreizeiler('','   '+intToStr(g1),'');
      Dreizeiler(intToStr(z1),'-',intToStr(n1));
      Dreizeiler('',' = ','');
      Dreizeiler(intToStr(z10),'-',intToStr(n1));
      Dreizeiler('','   ','');
    End;
    if g2<>0 then Begin
      Dreizeiler('','   '+intToStr(g2),'');
      Dreizeiler(intToStr(z2),'-',intToStr(n2));
      Dreizeiler('',' = ','');
      Dreizeiler(intToStr(z20),'-',intToStr(n2));
    End;
    text:=text+'*) Produkt=Zhler mal Zhler durch Nenner mal Nenner'#13#10+
          #13#10#13#10#13#10;
    Dreizeiler('','   Produkt=','');
    Dreizeiler(intToStr(z10)+'*'+intToStr(z20),'-',
               intToStr(n1) +'*'+intToStr(n2));
    text:=text+'*) Jetzt noch einmal ber Kreuz krzen, falls mglich'#13#10#13#10#13#10#13#10;
    Dreizeiler('','   ','');
    Textkuerze(0,z10,n2); //0=dummy
    Textkuerze(0,z20,n1);
    z:=z10*z20;
    n:=n1*n2;
    kuerze(z,n);
    Text:=text+#13#10#13#10#13#10;
    Dreizeiler('','*) Ergebnis = ','');
    Dreizeiler(inttoStr(z),'-',intToStr(n));
    gemZahl(z,n,q,r);
    if q<>0 then Begin
      Dreizeiler('',' = '+intToStr(q),'');
      Dreizeiler(inttostr(r),'-',intToStr(n));
    End;
  End;
end;


procedure  multipliziere(g1,g2,z1,n1,z2,n2:integer; var g,z,n:integer);
begin
  Nachhilfemultiplizieren(g1,g2,z1,n1,z2,n2);
  //Als unechte Brche schreiben
  kuerze(z1,n1);
  kuerze(z2,n2);
  z1:=z1+g1*n1;
  z2:=z2+g2*n2;
  z:=z1*z2;
  n:=n1*n2;
  kuerze(z,n);
  gemZahl(z,n,g,z);
end;

procedure Nachhilfedividieren(g1,g2,z1,n1,z2,n2:integer);
  var z10,z20,z,n,q,r:integer;
begin
  with Form1 do Begin
    l1.Caption:='Dividend';
    l2.Caption:='Divisor';
    lerg.Caption:='Quotient';
  End;
  with Form1.memo1 do Begin
    NachHilfeAnfangstext('Dividieren',g1,z1,n1,g2,z2,n2);
    if (g1<>0) or (g2<>0) then
      text:=text+'*) Gemischte Zahl in unechten Bruch umwandeln:'#13#10#13#10#13#10#13#10;
    z10:=z1+g1*n1;
    z20:=z2+g2*n2;
    if g1<>0 then Begin
      Dreizeiler('','   '+intToStr(g1),'');
      Dreizeiler(intToStr(z1),'-',intToStr(n1));
      Dreizeiler('',' = ','');
      Dreizeiler(intToStr(z10),'-',intToStr(n1));
      Dreizeiler('','   ','');
    End;
    if g2<>0 then Begin
      Dreizeiler('','   '+intToStr(g2),'');
      Dreizeiler(intToStr(z2),'-',intToStr(n2));
      Dreizeiler('',' = ','');
      Dreizeiler(intToStr(z20),'-',intToStr(n2));
    End;
    text:=text+'*) Quotient=1. Bruch * Kehrwert des 2. Bruchs'#13#10+
          #13#10#13#10#13#10;
    Dreizeiler('','   Quotient=','');
    Dreizeiler(intToStr(z10)+'*'+intToStr(n2),'-',
               intToStr(n1) +'*'+intToStr(z20));
    text:=text+'*) Jetzt noch einmal ber Kreuz krzen, falls mglich'#13#10#13#10#13#10#13#10;
    Dreizeiler('','   ','');
    Textkuerze(0,z10,z20);
    Textkuerze(0,n2,n1);
    z:=z10*n2;
    n:=n1*z20;
    kuerze(z,n);
    Text:=text+#13#10#13#10#13#10;
    Dreizeiler('','*) Ergebnis = ','');
    Dreizeiler(inttoStr(z),'-',intToStr(n));
    gemZahl(z,n,q,r);
    if q<>0 then Begin
      Dreizeiler('',' = '+intToStr(q),'');
      Dreizeiler(inttostr(r),'-',intToStr(n));
    End;
  End;
end;


procedure  dividieren(g1,g2,z1,n1,z2,n2:integer; var g,z,n:integer);
begin
  Nachhilfedividieren(g1,g2,z1,n1,z2,n2);
  //Als unechte Brche schreiben
  kuerze(z1,n1);
  kuerze(z2,n2);
  z1:=z1+g1*n1;
  z2:=z2+g2*n2;
  z:=z1*n2; //Kehrwert von z2/n2 ist n2/z1
  n:=n1*z2;
  kuerze(z,n);
  gemZahl(z,n,g,z);
end;




function copyab(const s:string; const i:integer):string;
  begin result:=copy(s,i,length(s)-i+1) end;

procedure loescheLeerzeilenimMemo;
  var k:integer;
begin
  with form1.memo1 do for k:=0 to lines.Count-1 do
    if trim(lines[k])='' then Begin
      lines.delete(k);
      loescheLeerzeilenimMemo; //rekursiv
      exit;
    End;
end;

procedure TForm1.BGleichClick(Sender: TObject);
  var g1,g2,g,z1,z2,z,n1,n2,n:integer;
      c:char;
      //1. Bruch g1'z1/n1 2.Bruch g2'z2/n2 Ergebnis g'z/n
  procedure Einlesen(const eg,ez,en:Tedit;var g,z,n:integer);
    begin
      if (trim(eg.text)='') and (pos('-',ez.text)=1) then Begin //Minuszeichen vor Bruch
        eg.text:='-';                                           //statt im Zhler
        ez.text:=copyab(ez.text,2);
      End;
      if trim(eg.text)='-' then Begin //negativer Bruch
         g:=0;
         z:=-strToInt(ez.text);
         n:=strToInt(en.text);
      End else Begin
        if trim(eg.text)>'' then g:=StrToInt(eg.text) else g:=0;
        if trim(ez.text)>'' then BEgin
          z:=strToInt(ez.text);
          n:=strToInt(en.text);
          if g<0 then z:=-abs(z);
        ENd else BEgin //ganze Zahl
          en.text:='';
          z:=0;
          n:=1;
        ENd;
      End;
    end;
begin
 eg1.SetFocus; //Fr die nchste Eingabe
 try Einlesen(eg1,ez1,en1,g1,z1,n1)
   except showmessage('Zahlen im 1. Bruch nicht korrekt'); exit End;
 try Einlesen(eg2,ez2,en2,g2,z2,n2);
   except showmessage('Zahlen im 2. Bruch nicht korrekt'); exit End;
  if (sender<>nil) and  (sender<>LGleich) then
  //Im Objektinspektor wurden die tags gesetzt
  case (sender as TButton).tag of 1: c:='+';
                                  2: c:='-';
                                  3: c:='*';
                                  4: c:='/';
        else c:='?'; //Dann keine Compilerwarnung
  End else Begin
    if eop.text>'' then c:=eop.text[1] else c:='+';
  End;
  if not (c in ['+','-','*','/']) then Begin
    //Keiner oder falscher Operant eingegeben
    showmessage('Bitte auf +,-,* oder / klicken');
    exit;
  End;
  Eop.text:=c;
  //try
    case c of '+': addiere      (g1,g2,z1,n1,z2,n2,g,z,n);
              '-': subtrahiere  (g1,g2,z1,n1,z2,n2,g,z,n);
              '*': multipliziere(g1,g2,z1,n1,z2,n2,g,z,n);
              '/': dividieren(g1,g2,z1,n1,z2,n2,g,z,n);
    End;
  //except showmessage('Fehler: Keine, zu groe Zahl oder Division durch 0'); exit End;
  if abs(g)>0 then eg.text:=IntToStr(g) else Begin
    if z>0 then eg.text:='' else if z=0 then eg.text:='0' else eg.text:='-';
  End;
  if abs(z)>0 then Begin
    ez.text:=IntToStr(abs(z));
    en.text:=IntToStr(n);
  End else Begin
    ez.text:='';
    en.text:='';
  End;
  if (c in ['+','-']) and (Bart.caption=unecht)
    then memo1.lines.add('Auch richtig:Die unechten Brche zuerst in'#13#10+
                         '             gemischte Zahlen umwandeln.');
  loescheLeerzeilenimMemo;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  showmessage('Denke daran!'#13+
              'Drei mal in der Woche 30 Minuten gebt ist '+
              'besser als einmal in der Woche drei Stunden.');
  close
end;

procedure TForm1.Ez1KeyPress(Sender: TObject; var Key: Char);
begin
  //En1Keypress durch Objektinspektor Ez1Keypress zugewiesen
  if (key=#13) or (key='/') then Begin
    key:=#0;
    if sender=eg1 then ez1.SetFocus else
    if sender=ez1 then en1.SetFocus else
    if sender=en1 then eop.SetFocus else
    if sender=eop then eg2.SetFocus else
    if sender=eg2 then ez2.SetFocus else
    if sender=ez2 then en2.SetFocus else
    if sender=en2 then BGleichClick(nil);
  End;
end;

procedure grauOderWeiss(e:Tedit);
begin
  if trim(e.text)='' then e.color:=clSilver else e.color:=clwhite;
end;


procedure TForm1.Ez1Change(Sender: TObject);
begin
  eg.text:='';
  ez.text:='';
  en.text:='';
  memo1.text:='';
  l1.caption:='';
  l2.caption:='';
  lErg.caption:='';
  if (sender=eg1) or (sender=eg2) then grauOderWeiss(sender as Tedit);
end;

procedure naechsteNr(const s:string; sender:Tobject);
  var z,a:string; //Zahl, Alphanumerisch
      zi,ai,k:integer;
begin
  z:='';
  a:='';
  for k:=1 to length(s) do
    if s[k] in ['0'..'9'] then z:=z+s[k] else if s[k] in ['a'..'k'] then a:=a+s[k];
  if a='' then a:=' ' else a:=lowercase(a);
  if z>'' then zi:=StrToInt(z) else zi:=1;
  ai:=ord(a[1])-ord('a');
  if ai<0 then ai:=-1;
  if sender=form1.BAufgabe then Begin
    if ai>=8 then BEgin
      inc(zi);
      ai:=0
    ENd else inc(ai);
  form1.Enr.text:=IntToStr(zi)+' '+char(ai+ord('a'));
  End;
  randseed:=10*zi+ai;
end;





procedure TForm1.BAufgabeClick(Sender: TObject);
  var g1,z1,n1,g2,z2,n2,a:integer;
      c:char;
  procedure level(const max,erw:integer);
      var e:integer; ////Mit e=random(erw)+1 muss zuerst gekzt werden
    procedure echt_unecht_gemZahl(var g,z,n:integer);
      begin
        g:=0;
        z:=z mod n; //echter Bruch
        if z=0 then z:=1;
        if Bart.caption=gemischt then g:=random(erw div 2)+1 else
        if Bart.caption=unecht then z:=z+(random(erw div 2)+1)*n;
      end;
    begin
      z1:=max div 3 + random(max-max div 3)+1;
      n1:=max div 3 + random(max-max div 3)+1;
      kuerze(z1,n1);
      e:=erw div 3 + random(erw-erw div 3);
      z1:=z1*e;
      n1:=n1*e;
      echt_unecht_gemZahl(g1,z1,n1);
      z2:=max div 2 + random(max-max div 2)+1;
      n2:=max div 2 + random(max-max div 2)+1;
      kuerze(z2,n2);
      e:=erw div 2 + random(erw-erw div 2)+1;
      z2:=z2*e;
      n2:=n2*e;
      echt_unecht_gemZahl(g2,z2,n2);
    end;
begin
  //setze randseed
  if (eNr.text='') or (Enr.text='Bsp.') then eNr.text:='1'+pred('a');
  naechsteNr(eNr.text,sender);
  memo1.text:='';
  with Blevel do
    if caption=leicht then level(10,10) else
      if  caption=mittel then level(20,10) else
        if  caption=schwer then level(10,20) else level(20,20);
  Ez1.text:=intToStr(z1);
  En1.text:=intToStr(n1);
  Ez2.text:=intToStr(z2);
  En2.text:=intToStr(n2);
  if g1>0 then Eg1.text:=IntToStr(g1) else eg1.text:='';
  if g2>0 then Eg2.text:=IntToStr(g2) else eg2.text:='';
  a:=random(100);
    if a>60 then c:='+' else   //40% '+'
      if a>30 then c:='-' else //30% '-'
        if a>10 then c:='/'    //20% '/'
          else c:='*';         //10% '*'
  Eop.text:=c;
end;

procedure TForm1.BLevelClick(Sender: TObject);
begin
  with Blevel do
    if Caption=leicht then Caption:=mittel else
    if Caption=mittel then Caption:=schwer else
    if Caption=schwer then Caption:=sehrschwer else
    if Caption=sehrschwer then Caption:=leicht;
end;


procedure TForm1.EgChange(Sender: TObject);
begin
 grauOderWeiss(sender as Tedit);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 memo1.text:=hilfe;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //typ:=0;
  //randomize; entfllt Siehe Randseed
  top:=20;
  Bart.caption := echt;
  Blevel.caption := leicht;
  memo1.text:=hilfe;
  Enr.text:='Bsp.'
end;

procedure TForm1.ENrKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then BAufgabeClick(Sender);
end;

procedure TForm1.ENrClick(Sender: TObject);
begin
  enr.SelectAll;
end;

procedure TForm1.BArtClick(Sender: TObject);
begin
 with Bart do
    if Caption=echt then Caption:=unecht else
    if Caption=unecht then Caption:=gemischt else
    if Caption=gemischt then Caption:=echt;
 Enr.text:='1 a';
 BAufgabeClick(Nil);
end;

function char_0(const s: string; const k: integer): char;
begin if (k <= 0) or (k > length(s)) then result := #0 else
    result := s[k]
end;

function char_l(const s: string; const k: integer): char;
begin
  result := char_0(s, k);
  if result = #0 then result := ' '
end;


function char_last(const s: string): char;
begin result := char_0(s, length(s)) end;


procedure TForm1.ENrChange(Sender: TObject);
begin
 if (char_last(enr.Text) in ['a'..'z']) then
    BAufgabeClick(Sender);
end;

end.



